.486
.MODEL FLAT

.CODE
_run:

include         ..\stdparas.inc                         ; PA1-PA4

; *********************************************************************************************

src             EQU     <PA1>                           ; ptr: Source
ref             EQU     <PA2>                           ; ptr: RefArr  (min 16 dwords)
tgt             EQU     <PA3>                           ; ptr: Target  (8 dwords for hash)
def             EQU     <PA4>                           ; ptr: Defaults 64 dwords standards (k)
                                                        ;               08 dwords initial hash
                                                        ;               01 dword  flags
                                                        ;               01 dword  messagelen
                                                        
flg             EQU     <stack1>                        ; lng: Bit 0:   0=create hash
                                                        ;                 len=len(src)
                                                        ;               1=encrypt ref array
                                                        ;                 len=len(ref)
len             EQU     <stack2>                        ; lng: length/bytes
counter         EQU     <stack3>                        ; lng: loop1-counter
lenBy64         EQU     <stack4>                        ; lng: org src len before using stack

tmpA            EQU     <[esi+0]>
tmpB            EQU     <[esi+4]>
tmpC            EQU     <[esi+8]>
tmpD            EQU     <[esi+12]>
tmpE            EQU     <[esi+16]>
tmpF            EQU     <[esi+20]>
tmpG            EQU     <[esi+24]>
tmpH            EQU     <[esi+28]>

; *********************************************************************************************

SHA256          PROC    NEAR
                mac     SAVE

init:           mov     esi,def
                mov     edx,[esi+72*4]
                mov     eax,[esi+73*4]
                push    edx                             ; flags
                push    eax                             ; length

                sub     esp,(2+32+64+8)*4               ;  2 = stack3 to stack4
                                                        ; 32 = last block(s)
                                                        ; 64 = calculation buffer (W)
                                                        ;  8 = hash buffer (tmpA to tmpH)


                test    dl,1                            ; "calculate total number of blocks"
                jz      init_a
                test    al,63
                jnz     finish_err
                shr     eax,6                           ; flg/0=1: => counter = len\64
                jz      finish_err
                mov     counter,eax
                mov     lenBy64,-1
                jmp     init_d
                
init_a:         add     eax,9                           ; flg/0=0: => length acc. to src
                mov     cl,al
                shr     eax,6
                test    cl,63
                jz      init_b
                inc     eax
init_b:         mov     counter,eax
                
                lea     edi,[esp+((8+64)*4)]            ; "init last block (possibly 2)"
                mov     esi,len                         ; "with flg/0=0 only"
                mov     ecx,63
                and     ecx,esi
                xor     esi,ecx
                mov     lenBy64,esi                     ; lenBy64=(len\64)*64
                add     esi,src
                mov     ebx,55
                sub     ebx,ecx
                jnc     init_c                          ; (len mod 64) > 55
                add     ebx,64                          ; causes a second block
init_c:         rep     movsb
                mov     Byte Ptr [edi],80h              ; set most significant bit
                inc     edi
                mov     al,cl
                mov     cl,bl
                rep     stosb                           ; fill with zeroes
                mov     eax,len
                mov     cl,8
                mul     ecx
                bswap   edx
                bswap   eax
                mov     [edi],edx                       ; put total number of bits
                mov     [edi+4],eax                     ; into last two dwords

init_d:         mov     edi,tgt
                mov     esi,def                         ; "copy initial hash values"
                add     esi,64*4
                mov     ecx,8
                rep     movsd


                mov     edx,src                         ; "block loop"
LOOP1:          sub     lenBy64,64
                jnc     LOOP1_a
                lea     edx,[esp+((8+64)*4)]

LOOP1_a:        mov     edi,esp                         ; copy actual hash to (tmpA to tmpH)
                mov     esi,tgt
                mov     cl,8
                rep     movsd                

                mov     ebx,edi                         ; copy 16 dwords from src to buffer (W)
                mov     esi,edx
                mov     cl,15
                test    flg,1
                jnz     LOOP1_b2
LOOP1_b:        mov     eax,[esi+4*ecx]                 ; bswap them, if required
                bswap   eax
                mov     [edi+4*ecx],eax
LOOP1_b1:       dec     ecx
                jns     LOOP1_b
LOOP1_b2:       inc     ecx
                rep     movsd
                
                mov     esi,esp                         ; esi=>(tmpA to tmpH)
                push    edx
                xor     edx,edx
LOOP2:          cmp     edx,64  
                jc      LOOP2_a                         ; first 16 times, W(J) = src (s. above)

                mov     eax,[ebx-8]                     ; 1=gamma1(W(j-2))
                mov     ecx,eax
                mov     edi,eax
                ror     eax,17
                ror     ecx,19
                shr     edi,10
                xor     eax,ecx
                xor     eax,edi
                mov     [ebx],eax

                mov     eax,[ebx-60]                    ; 2=gamma0(W(j-15))
                mov     ecx,eax
                mov     edi,eax
                ror     eax,7
                ror     ecx,18
                shr     edi,3
                xor     eax,ecx
                xor     eax,edi

                add     eax,[ebx-28]                    ; 3=W(j-7)
                add     eax,[ebx-64]                    ; 4=W(j-16)
                add     [ebx],eax                       ; W(j)=1+2+3+4
                
LOOP2_a:        mov     eax,tmpE
                mov     edi,eax
                and     eax,tmpF                        ; (tmpE and tmpF)
                not     edi
                and     edi,tmpG                        ; ((not tmpE) and gmpG)
                xor     edi,eax

                mov     eax,tmpE                        ; sigma1(tmpE)
                mov     ecx,eax
                ror     eax,6
                ror     ecx,11
                xor     eax,ecx
                ror     ecx,14
                xor     eax,ecx

                add     eax,edi
                mov     edi,def
                add     eax,[edi+edx]                   ; k(j)
                add     eax,tmpH
                add     eax,[ebx]
                push    eax                             ; T1

                mov     eax,tmpA
                mov     edi,eax
                and     eax,tmpB                        ; (tmpA and tmpB)
                and     edi,tmpC                        ; (tmpA and tmpC)
                xor     eax,edi
                mov     edi,tmpB 
                and     edi,tmpC                        ; (tmpB and tmpC)
                xor     edi,eax

                mov     eax,tmpA                        ; sigma0(tmpA)
                mov     ecx,eax
                ror     eax,2
                ror     ecx,13
                xor     eax,ecx
                ror     ecx,9
                xor     eax,ecx

                add     eax,edi
                push    eax                             ; T2

                lea     edi,[esi+28]                    ; move tmpG-tmpA to tmpH-tmpB
                add     esi,24
                mov     ecx,7
                std
                rep     movsd
                cld
                mov     esi,edi
                pop     [esi]
                pop     eax
                add     [esi],eax                       ; tmpA = T2 + T1
                add     [esi+16],eax                    ; tmpE += T1

                add     ebx,4
                add     dl,4
LOOP2_end:      jnc     LOOP2

                mov     edi,tgt                         ; hash(0 to 7) += (tmpA to tmpH)
                mov     cl,7
LOOP1_c:        mov     eax,[esi+4*ecx]
                add     [edi+4*ecx],eax
                dec     ecx
                jns     LOOP1_c
                inc     ecx
                
                pop     edx
                mov     edi,ref
                sub     ebx,16*4
                mov     cl,15
                test    flg,1
                jz      LOOP1_e

LOOP1_d:        mov     eax,[ebx+4*ecx]                 ; msgBlock xor wrk(48...)
                xor     [edi+4*ecx],eax                 ; refBlock xor wrk(48...)
                xor     [edx+4*ecx],eax
                dec     ecx
                jns     LOOP1_d
                inc     ecx
                
                add     ref,16*4
                dec     counter
                jnz     LOOP1_a
                jmp     finish
                
                
LOOP1_e:        mov     eax,[ebx+4*ecx]                 ; refBlock xor wrk(48...)
                xor     [edi+4*ecx],eax
                dec     ecx
                jns     LOOP1_e
                inc     ecx

                add     edx,16*4
                dec     counter
LOOP1_end:      jnz     LOOP1

finish:         stc
finish_err:     mac     RESTSP
SHA256          ENDP

END _run
